! class methods

  MEMBER

  map
  end

  include('RevBrw.inc')
  include('keycodes.clw'),once

DefaultBitMask   equate(1)
BaseMask         long       ! variable to use in bitwise ops

! ---------------------------------------
! begin class methods
! public
! ---------------------------------------

BrowseReverseClass.SetReverse procedure(long SortNumber = 0, byte Rev = false)
! set the Rev browse status,
! get the record then set the values passed and put it back

  code

  BaseMask = DefaultBitMask
  BaseMask = bshift(BaseMask, SortNumber - 1)
  Self.ReverseOrder = bxor(Self.ReverseOrder, BaseMask)
  if (Rev)  ! start order reversed
    Self.ReverseStatus = bxor(Self.ReverseStatus, BaseMask)
  end

  return
! SetReverse -------------------------------------------------------------------------------

BrowseReverseClass.SetHeaderReverse  procedure(long SortNumber = 0) 
! toggle flag that sorts on list box header
! if true will allow Reving the CURRENT sort order when the user double
! clicks on the header

Current      long,auto

  code

  BaseMask = DefaultBitMask
  BaseMask = bshift(BaseMask, SortNumber - 1)
  Self.ReverseOnClick = bxor(Self.ReverseOnClick, BaseMask)

  return
! SetHeaderRev  -------------------------------------------------------------------

! ----------------
! protected methods
! ---------------
BrowseReverseClass.SetRevAlertKey procedure(long k = AltV) ! protected

  code

  ! set the alert value for the list control and the class property
  Self.ILC.GetControl(){prop:alrt,255} = k
  Self.RevKeyCode = k

  return
! end SetKeyCode -----------------------------------------------------------------------

! ----------------
! private methods
! ---------------

BrowseReverseClass.ToggleSort  procedure  !private
! toggle the current Rev status for the current sort order

  code

  if (band(BaseMask, Self.ReverseOrder))         ! if sort order is active flip else ignore
    ! flip the current value and put it back
    Self.ReverseStatus = bxor(Self.ReverseStatus, BaseMask)
    ! reset the sort
    Self.ResetSort(true)
  end ! if

  return
! ToggleSort --------------------------------------------------------------------------

! -------------
! virtual methods
! -------------

BrowseReverseClass.Next PROCEDURE  !BYTE,VIRTUAL
! if Rev true call previous if false call next

ReturnValue              byte,auto

  code

  if (band(Self.ReverseStatus, BaseMask))
    ReturnValue = parent.Previous()
  else
    ReturnValue = parent.Next()
  end

  return(ReturnValue)
! Next -------------------------------------------------------------------------------------

BrowseReverseClass.Previous   procedure !byte virtual
! if Rev true then call next if false then call previous

ReturnValue              byte,auto

  code

  if (band(Self.ReverseStatus, BaseMask))
    ReturnValue = parent.Next()
  else
    ReturnValue = parent.previous()
  end

  return(ReturnValue)
! Previous --------------------------------------------------------------------------------

BrowseReverseClass.SetSort  PROCEDURE(BYTE NewOrder,BYTE Force)  !BYTE,VIRTUAL,PROC
! set sort adjust the current RevOrders queue and call the parent

  code

  BaseMask = DefaultBitMask
  BaseMask = bshift(BaseMask, NewOrder - 1)

  return parent.SetSort(NewOrder, Force)

! SetRev ---------------------------------------------------------------------------

BrowseReverseClass.TakeKey    procedure() ! BYTE,PROC,VIRTUAL
! method to handle mouse clicks on list box header

ListControl            unsigned,auto      ! set to list control feq
ReturnValue            byte(false)        ! retun byte

  code

  ListControl = Self.ILC.GetControl()
  ! was header double clicked 
  if keycode() = MouseLeft2 and ListControl{proplist:MouseDownRow} = 0 and ListControl{proplist:MouseDownField} <> 0
    ! user double clicked on list box header
    ! if allowed on this sort order then toggle
    if (band(BaseMask, Self.ReverseOnClick))
      Self.ToggleSort()
    end
    ! return false if key was handled here
    ReturnValue = true
  elsif keycode() = Self.RevKeyCode
    ! if alrt key was pressed
    if (band(BaseMask, Self.ReverseOrder))
      Self.ToggleSort()
    end
    ! return false if key was handled here
    ReturnValue = true
  end
  if (~ReturnValue)
    ! key was NOT handled call parent
    ReturnValue = parent.TakeKey()
  end ! if

  return(ReturnValue)
! TakeKey ---------------------------------------------------------------------